<?
  /* OBSERVAES:
     1) A VARIAVEL $DIR CONTEM O DIRETORIO LOCAL E  TRANSMITIDA ATRAVES DE URL
	 2) A VARIAVEL $RAIZ CONTEM O DIRETORIO ONDE ESTO OS ARQUIVOS DO FTP
  */
/* ----------------------------------------------------------------------------*/
  // FUNCO PARA CONECTAR NO BANCO DE DADOS
  function conectar($host, $login, $senha, $db) {
	if (! $banco= @mysql_connect($host, $login, $senha)) {include("erro_connect.php"); exit;}
	if (! @mysql_select_db($db, $banco)) {include("erro_db.php"); exit;}
  }
  function desconectar() {
    @mysql_close($banco);
  }
  function query($sql) {
    $resp= @mysql_query($sql) or die("Erro na Query: ".$sql."<br><a href='index.php'>Voltar</a>");
    return $resp;
  }
  //  USADO PARA AUTOCOMPLETAR O LOGIN / DOMINIO DO USUARIO
  function ver_dominio($login) {
    $dominio= strstr($login, "@");
	return $dominio;
  }
/* ----------------------------------------------------------------------------
   FUNES PARA ENTRAR E VOLTAR DE PASTAS
*/
  // VOLTAR E ENTRAR EM PASTAS
  function entrar_pasta($nm) {
    $pasta= $dir.$nm;
	return $pasta;
  }
  // CAPTURA PASTA ANTERIOR
  function voltar_pasta($loc) {
    $tam= strlen($loc);
	$retira="";
	while ($tam > 0) {
	  if ($loc[$tam] != "/") $retira= $loc[$tam].$retira;
	  else break;
	  $tam--;
	}
	$volta= str_replace("/".$retira, "", $loc);
    if ($volta != "") return $volta; // Endereo da pagina anterior
	else return false; // Esta na Raiz
  }
/* ----------------------------------------------------------------------------
   FUNES DE SESSO
   ESTAS FUNES SO USADAS PARA VERIFICAR SE
   O USUARIO CONECTOU NO SITE E PARA
   DESCONECTA-LO DO SITE
*/
  
  // VERIFICA SE A SESSAO ESTA ATIVA
  function ver_sessao() {
    if (session_start()) {
	  if (!(session_is_registered("conta") and
	        session_is_registered("login") and
	        session_is_registered("nm_usr") and
			session_is_registered("tam_tot_ftp") and
			session_is_registered("tam_usado_ftp"))) {
	    include("erro_permicao.php");
		session_destroy();
		exit;
	  }
	}
	else {
	  include("erro_cria_sessao.php");
	  exit;
	}
  }
  // FAZ LOGOUT DO SITE
  function logout() {
    if (session_start()) {	  
		session_unregister("conta");
		session_unregister("login");
		session_unregister("nm_usr");
		session_unregister("tam_usado_ftp");
		session_unregister("tam_tot_ftp");
		session_destroy();
		return true;
	}
  }
  
/* ----------------------------------------------------------------------------
   FUNES PARA VARIAVEIS STRING
   ESTAS FUNES SO USADAS PARA REMOVER CARACTERES
   ADICIONADOS QUANDO VARIAVEIS SO PASSADAS POR
   SUBMIT
*/
  
  // REMOVE BARRAS DUPLICADAS
  function busca_estencao($raiz, $nm) {
	/* TIPOS:
	  EXTENSION -> retorna a exteno do arquivo
	  BASENAME -> retorna o nome do arquivo
	  DIRNAME -> retorna o diretorio do arquivo
	  
	  obs: para achar a BASENAME e DIRNAME tem que ser passado o diretorio do arquivo
	*/
	$tipo= pathinfo($raiz."/".$nm);
	return $tipo["extension"];
  }
  // FUNES DE TEXTO
  function tags_html($txt) {
    $texto= $txt;
    $tam_texto= strlen($texto);
    $i=0;
	$txt= "";
    while ($i < $tam_texto) {
	  # onde tiver uma barra invertida, ele apaga ela e pula duas casas
	  if ($texto[$i] == "\\" and $texto[$i+1] == "\\") { $txt.= "\\"; $i++; }
	  elseif ($texto[$i] == "\\" and $texto[$i+1] == "'") { $txt.= "'"; $i++; }
	  elseif ($texto[$i] == "\\" and $texto[$i+1] == "\"") { $txt.= "\""; $i++; }
	  else {$txt.= $texto[$i];}
	  $i++;
	}
    return $txt;
  }
  // CAPTURA CONTEUDO TEXTO DE UM ARQUIVO
  function captura_texto($loc, $arq) {
    $arquivo= fopen($loc."/".$arq, "r");
	while (!feof($arquivo)){
	  $txt= fread($arquivo, 4096);
	}
	fclose($arquivo);
    return $txt;
  }
/* ----------------------------------------------------------------------------
   FUNES PARA ARQUIVOS E PASTAS
   ESTAS FUNES SO PARA GERENCIAR ARQUIVOS
   E PASTAS NO SERVIDOR
*/
  
  // FUNES DE TRANSFERENCIA DE ARQUIVO
  function download($raiz, $nm_arq) {
    $loc= $raiz."/".$nm_arq;
    header("Content-type: application/save");
	header('Content-Disposition: attachment; filename="' . basename($loc) . '"');
	header('Expires: 0');
	header('Pragma: no-cache');
	readfile("$loc");
  }
  
  // FUNES DE REMOO DE DADOS
  function delete_arquivo($raiz, $arq) {
    @unlink($raiz."/".$arq);
  }
  // APAGA VRIOS ARQUIVOS SIMULTANEAMENTE
  function delete_n_arquivos($raiz, $array_arq) {
    for ($i=0; $i < sizeof($array_arq); $i++) {
	  delete_arquivo($raiz, $array_arq[$i]);
	}
  }
  // APAGA DIRETORIO VAZIO
  function delete_pasta($raiz, $pasta) {
    @rmdir($raiz."/".$pasta);
  }
 
  // FUNES DE CRIAO DE DADOS
  function cria_arquivo($raiz, $nm) {
    $nm= str_replace(" ", "_", $nm);
	$arq= fopen($raiz."/".$nm, "a+");
	fclose($arq);
	if (file_exists($raiz."/".$nm)) return true;
	else return false;
  }
  function cria_pasta($raiz, $nm) {
    $nm= str_replace(" ", "_", $nm);
	if (mkdir($raiz."/".$nm, 0775)) return true;
	else return false;
  }
  
  // FUNES DE RENOMEAO DE DADOS
  function renomeia_arquivo($raiz, $nm, $new_nm) {
    if (rename($raiz."/".$nm, $raiz."/".$new_nm)) return true;
	else return false;
  }
  function renomeia_pasta($raiz, $nm) {
    
  }
  
  // FUNO DE COPIA DE ARQUIVO
  function copia_arquivo($de, $para, $nm_arq) {
    if (copy($de."/".$nm_arq, $para."/".$nm_arq)) return true;
	else return false;
  }
  
  // COMPACTAO E DESCOMPACTAO DE ARQUIVOS ZIP
  function compactar($nm) {
    return true;
  }
  function descompactar($nm) {
    return true;
  }
  
/* ----------------------------------------------------------------------------
   FUNES QUE SO USADAS PARA CAPTURAR DADOS SOBRE OS
   ARQUIVOS E PASTAS DENTRO DO SERVIDOR.
   ESTES DADOS PODEM SER USADOS PARA RESTRINGIR
   OPES OU FUNES PARA O PROGRAMADOR
*/
  // Tamanho que est ocupando o ftp
  function tam_ocupado_ftp($usado, $maximo){
    $tot= ($usado * 100)/$maximo;
    return round($tot, 2);
  }
  // Tamanho de um arquivo especifico
  function tamanho_arquivo($raiz, $arquivo) {
    # OBS: A PASTA TEM QUE SER PASSADA SEM BARRA NO FINAL
    $loc= $raiz."/".$arquivo;
    $tamanho= ceil(filesize($loc)/1024);
	return $tamanho;
  }
  // Tipo do arquivo
  function tipo_arquivo($raiz, $arquivo) {
    $tipo= $raiz."/".$arquivo;
	return tipo;
  }
  // Ordena um array
  function ordena_array($array) {
    if (is_array($array)) {
	  @sort($array);
	  @reset($array);
      return $array;
	}
	else return false;
  }
  // Captura nome de arquivos e pasta do diretorio desejado
  function lista_arquivos($raiz, $pasta) {
    # OBS: A PASTA TEM QUE SER PASSADA SEM BARRA NO FINAL
    $diretorio= $raiz."/".$pasta;
	if (! $d= @dir($diretorio)) return "<br>Erro no diret&oacute;rio<br>\n";
    $array_dir= ""; $i_dir=0;
	$array_arq= ""; $i_arq=0;
	while ($entry= $d-> read()) { // captura nome dos arquivos
	  $nome= $entry;
	  if ($nome != "") {
	    $loc= $diretorio."/".$nome;
	    if (is_dir($loc)) {
	      if ($nome != "." and $nome != "..") {
	        $array_dir[$i_dir]= $nome;
		    $i_dir++;
		  }
	    }
	    else {
	      if ($nome != "") {
	        $array_arq[$i_arq]= $nome;
		    $i_arq++;
		  }
	    }
	  }
	}
	$d-> close();
	$a_dir= ordena_array($array_dir);
	$a_arq= ordena_array($array_arq);
	// Junta os array em um s
	$arquivos= "";
	$tot_arq= $i_dir + $i_arq;
    for ($i=0; $i < $tot_arq; $i++) {
	  if ($i < $i_dir) {
	    $arquivos[$i]= $a_dir[$i];
	  }
	  else {
	    $arquivos[$i]= $a_arq[$i - $i_dir];
	  }
	}
    return $arquivos;
  }
  // Retorna o tamanho de uma pasta especifica
  /* Variaveis:
       - Raiz: contem a raiz onde esta a pasta
	   - Pasta: nome da pasta a ser vasculhada
	   - Opc: opo de vasculha:
	       * T -> tamanho ocupado pela pasta
		   * E -> excluir pasta com arquivos dentro
  */
  function opc_pasta($raiz, $pasta, $opc) {
    $tamanho= 0;
	// Cria local dos arquivos
	$loc= "";
	$loc= $raiz;
	if ($pasta != "") $loc= $raiz."/".$pasta;
	// Busca arquivos e pastas
	$arq= lista_arquivos($raiz, $pasta);
	$i=0;
	if ($arq[0] != "") {
      while ($i < sizeof($arq)) {
	    if (is_dir($loc."/".$arq[$i])) {
	      $tamanho+= opc_pasta($loc, $arq[$i], $opc);
		  if ($opc == "E") delete_pasta($loc, $arq[$i]);
	    }
	    else {
		  $tamanho+= tamanho_arquivo($loc, $arq[$i]);
		  if ($opc == "E") delete_arquivo($loc, $arq[$i]);
	    }
	    $i++;
	  }
	}
	if ($opc == "E") delete_pasta($raiz, $pasta);
    return $tamanho;
  }
?>